<script setup lang="ts">
    import { graphql } from "./../gql/index";
    import { computed } from "vue";
    import { useQuery } from "@vue/apollo-composable";
    import useNavigationStore, { defaultTabBase } from "./../stores/navigation";
    import useAuthStore from "./../stores/auth";
    import AddParticipantToEvent from "./RegisterCards/AddParticipantToEvent.vue";
    import BaseData from "./RegisterCards/BaseData.vue";
    import ExtensionData from "./RegisterCards/ExtensionData.vue";
    import UnregisterImportButton from "./UnregisterImportButton.vue";
    import ImportStateDisplay from "./ImportStateDisplay.vue";
    import { useRouter } from "vue-router";
    import { DynamicRoutePaths } from "../plugins/router";

    const navigationStore = useNavigationStore();
    const authStore = useAuthStore();
    const router = useRouter();

    navigationStore.$subscribe((_mutation, _state) => {
        router.push({ name: DynamicRoutePaths.ParticipantDetails }); // TODO move this out possibly
    });

    // graphql
    const participantQueryVariables = computed(() => {
        return {
            id: navigationStore.participantId,
        };
    });
    const participantQuery = graphql(`
        query ParticipantQuery($id: Uuid = "00000000-0000-0000-0000-000000000000") {
            participant(id: $id) {
                id
                familyName
                callName
                extensions {
                    id
                    event {
                        id
                        name
                        year
                        startDate
                    }
                }
            }
        }
    `);
    const { result: resultParticipant } = useQuery(participantQuery, participantQueryVariables, {
        fetchPolicy: "cache-and-network",
    });
    const participant = computed(() => {
        return resultParticipant.value?.participant!;
    });

    // computed value extractions
    const tabs = computed(() => {
        const extensions = participant?.value?.extensions! ?? [];
        let res = [];

        for (const extension of extensions ?? []) {
            res.push({
                extension_id: extension.id,
                event_name: extension.event?.name ?? "",
                event_year: extension.event?.year ?? 0,
                event_id: extension.event?.id,
                event_startDate: extension.event?.startDate,
            });
        }

        // more recent events are more to the left
        res.sort((a, b) => {
            return b.event_startDate.localeCompare(a.event_startDate);
        });

        return res;
    });
</script>

<template>
    <div class="pa-3">
        <h2 class="text-center">Teilnehmer</h2>

        <div style="display: flex; width: 100%">
            <ImportStateDisplay :for-tab="navigationStore.participantViewTab" />
            <UnregisterImportButton style="margin-left: auto" />
        </div>

        <v-card v-if="participant && participant != null" variant="tonal" class="my-2">
            <template v-slot:title> Teilnehmer: {{ participant.callName }} {{ participant.familyName }} </template>
            <template v-slot:text>
                <v-tabs v-model="navigationStore.participantViewTab">
                    <v-tab :value="defaultTabBase"> Stammdaten </v-tab>
                    <v-tab value="add" v-if="authStore.hasWriteParticipant">
                        <span class="material-symbols-outlined"> add </span>
                    </v-tab>
                    <v-tab v-for="tab in tabs" :value="tab.event_id">{{ tab.event_name }} ({{ tab.event_year }})</v-tab>
                </v-tabs>

                <v-card-text>
                    <v-window v-model="navigationStore.participantViewTab">
                        <v-window-item :value="defaultTabBase">
                            <h2 class="mb-5">Stammdaten:</h2>
                            <BaseData></BaseData>
                        </v-window-item>
                        <v-window-item value="add" v-if="authStore.hasWriteParticipant">
                            <h2 class="mb-5">Füge Teilnehmer zu Veranstaltung hinzu:</h2>
                            <AddParticipantToEvent></AddParticipantToEvent>
                        </v-window-item>
                        <v-window-item v-for="tab in tabs" :value="tab.event_id">
                            <h2 class="mb-5">
                                {{ participant.callName }} {{ participant.familyName }}: {{ tab.event_name }} ({{
                                    tab.event_year
                                }})
                            </h2>
                            <ExtensionData :extension-id="tab.extension_id"></ExtensionData>
                        </v-window-item>
                    </v-window>
                </v-card-text>
            </template>
        </v-card>
    </div>
</template>
